summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author pyllyukko2018-07-06 18:02:05 +0200
committer Willy Sudiarto Raharjo2018-07-07 01:54:18 +0200
commita754bbc792ecca91d7e951bd10e46ff715bec958 (patch)
tree68628ef9aa56f7f95e652b4e1d4030c518a955e2
parenta274538685d16c0f4e6a6e05121a2600f010bc11 (diff)
downloadslackbuilds-a754bbc792ecca91d7e951bd10e46ff715bec958.tar.gz
system/apparmor: Added (Mandatory Access Control mechanism).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--system/apparmor/README9
-rw-r--r--system/apparmor/apparmor.SlackBuild158
-rw-r--r--system/apparmor/apparmor.info10
-rw-r--r--system/apparmor/doinst.sh31
-rw-r--r--system/apparmor/slack-desc19
5 files changed, 227 insertions, 0 deletions
diff --git a/system/apparmor/README b/system/apparmor/README
new file mode 100644
index 0000000000..06c07e32c0
--- /dev/null
+++ b/system/apparmor/README
@@ -0,0 +1,9 @@
+AppArmor protects systems from insecure or untrusted processes by running them
+in restricted confinement, while still allowing processes to share files,
+exercise privilege and communicate with other processes. AppArmor is a
+Mandatory Access Control (MAC) mechanism which uses the Linux Security Module
+(LSM) framework.
+
+Note that in order to use AppArmor, you need to have CONFIG_SECURITY_APPARMOR
+setting enabled in the kernel (which is not enabled by default in Slackware).
+So in order to use this, you need to reconfigure & recompile your kernel.
diff --git a/system/apparmor/apparmor.SlackBuild b/system/apparmor/apparmor.SlackBuild
new file mode 100644
index 0000000000..ab72993fbd
--- /dev/null
+++ b/system/apparmor/apparmor.SlackBuild
@@ -0,0 +1,158 @@
+#!/bin/sh
+
+# Slackware build script for AppArmor
+
+# Copyright 2018 pyllyukko
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=apparmor
+VERSION=${VERSION:-2.12}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo} # For consistency's sake, use this
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp} # Drop the package in /tmp
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-v$VERSION.tar.bz2
+cd $PRGNAM-v$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+export PYTHONPATH=$(realpath libraries/libapparmor/swig/python)
+export PYTHON=/usr/bin/python3
+export PYTHON_VERSION=3
+export PYTHON_VERSIONS=python3
+
+pushd ./libraries/libapparmor
+sh ./autogen.sh
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --with-perl \
+ --with-python \
+ --build=$ARCH-slackware-linux
+make
+make install DESTDIR=$PKG
+popd
+
+pushd binutils
+make
+make check
+make install DESTDIR=$PKG MANDIR=/usr/man
+popd
+
+pushd parser
+make
+make install DESTDIR=$PKG MANDIR=/usr/man
+popd
+mv -v ${PKG}/etc/apparmor/parser.conf ${PKG}/etc/apparmor/parser.conf.new
+mv -v ${PKG}/etc/apparmor/subdomain.conf ${PKG}/etc/apparmor/subdomain.conf.new
+mv -v ${PKG}/etc/rc.d/rc.apparmor ${PKG}/etc/rc.d/rc.apparmor.new
+
+pushd utils
+make
+make install DESTDIR=$PKG MANDIR=/usr/man
+popd
+mv -v ${PKG}/etc/apparmor/easyprof.conf ${PKG}/etc/apparmor/easyprof.conf.new
+mv -v ${PKG}/etc/apparmor/logprof.conf ${PKG}/etc/apparmor/logprof.conf.new
+mv -v ${PKG}/etc/apparmor/notify.conf ${PKG}/etc/apparmor/notify.conf.new
+mv -v ${PKG}/etc/apparmor/severity.db ${PKG}/etc/apparmor/severity.db.new
+
+# Apache
+#pushd changehat/mod_apparmor
+#make
+#make install DESTDIR=$PKG MANDIR=/usr/man
+#popd
+
+pushd profiles
+make
+make install DESTDIR=$PKG
+popd
+
+# Strip binaries and libraries
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Compress man pages
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+find $PKG -name perllocal.pod \
+ -o -name ".packlist" \
+ -o -name "*.bs" \
+ | xargs rm -f
+
+# Copy program documentation into the package
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ LICENSE README documentation/ \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+# Copy the slack-desc and a custom doinst.sh into ./install
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+# Make the package
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/apparmor/apparmor.info b/system/apparmor/apparmor.info
new file mode 100644
index 0000000000..2755785c32
--- /dev/null
+++ b/system/apparmor/apparmor.info
@@ -0,0 +1,10 @@
+PRGNAM="apparmor"
+VERSION="2.12"
+HOMEPAGE="https://gitlab.com/apparmor/"
+DOWNLOAD="https://gitlab.com/apparmor/apparmor/-/archive/v2.12/apparmor-v2.12.tar.bz2"
+MD5SUM="3591dc32db552ab5ed2b5d842100ac17"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="python3"
+MAINTAINER="pyllyukko"
+EMAIL="pyllyukko AT maimed dot org"
diff --git a/system/apparmor/doinst.sh b/system/apparmor/doinst.sh
new file mode 100644
index 0000000000..7715ef2c3a
--- /dev/null
+++ b/system/apparmor/doinst.sh
@@ -0,0 +1,31 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+preserve_perms etc/rc.d/rc.apparmor.new
+config etc/apparmor/easyprof.conf.new
+config etc/apparmor/logprof.conf.new
+config etc/apparmor/notify.conf.new
+config etc/apparmor/parser.conf.new
+config etc/apparmor/subdomain.conf.new
+config etc/apparmor/severity.db.new
diff --git a/system/apparmor/slack-desc b/system/apparmor/slack-desc
new file mode 100644
index 0000000000..49666683a4
--- /dev/null
+++ b/system/apparmor/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+apparmor: apparmor (Mandatory Access Control mechanism)
+apparmor:
+apparmor: AppArmor protects systems from insecure or untrusted processes by
+apparmor: running them in restricted confinement, while still allowing
+apparmor: processes to share files, exercise privilege and communicate with
+apparmor: other processes. AppArmor is a Mandatory Access Control (MAC)
+apparmor: mechanism which uses the Linux Security Module (LSM) framework.
+apparmor:
+apparmor:
+apparmor: Homepage: https://gitlab.com/apparmor/
+apparmor: